extern volatile int Frama_C_entropy_source;

/*@ assigns \result \from min, max, Frama_C_entropy_source;
    assigns Frama_C_entropy_source \from Frama_C_entropy_source;
    ensures min <= \result <= max ;
 */
extern int Frama_C_interval(int min, int max);
/*{
  int n = Frama_C_entropy_source;
  if (min <= n && n <= max)
    return n;
  else
    return min;
    }*/

/*@ requires 0 <= n && \valid(a+(0..n-1));
    assigns \nothing;
    ensures \result == -1 ==> (\forall integer i; 0<= i < n ==> a[i] != v);
    ensures 0 <= \result < n ==> a[\result] == v;
    ensures -1 <= \result < n;
 */
int find(int n, const int a[], int v)
{
  int i;

  for (i=0; i < n; i++) {
    if (a[i] == v) {
      return i;
    }
  }

  return -1;
}

#define N 10

int main(void)
{
  int a[N];
  int i, n, result;

  for (i = 0; i < N; i++)
    a[i] = Frama_C_interval(-2147483648, 2147483647);

  while (1) {
    n = Frama_C_interval(0, N);
    result = find(n, a, 0);
  }

  return 0;
}
